#! /usr/bin/python

import sys
reload(sys)
sys.setdefaultencoding('utf-8')

try:
    sys.path.append('/usr/lib/cinnamon-settings/modules')
    sys.path.append('/usr/lib/cinnamon-settings/bin')
    import os
    import glob
    import gettext
    from gi.repository import Gio, Gtk, GObject, GdkPixbuf
    import SettingsWidgets
    import capi
# Standard setting pages... this can be expanded to include applet dirs maybe?
    mod_files = glob.glob('/usr/lib/cinnamon-settings/modules/*.py')
    mod_files.sort()
    if len(mod_files) is 0:
        raise Exception("No settings modules found!!")
    for i in range(len(mod_files)):
        mod_files[i] = mod_files[i].split('/')[5]
        mod_files[i] = mod_files[i].split('.')[0]
        if mod_files[i][0:3] != "cs_":
            raise Exception("Settings modules must have a prefix of 'cs_' !!")
    modules = map(__import__, mod_files)
except Exception, detail:
    print detail
    sys.exit(1)

# i18n
gettext.install("cinnamon", "/usr/share/cinnamon/locale")
# i18n for menu item
menuName = _("System Settings")
menuComment = _("Control Center")
NormalMode = _("Switch to Normal Mode")
AdvancedMode = _("Switch to Advanced Mode")

ADVANCED_GSETTING = "cinnamon-settings-advanced"

WIN_WIDTH = 800
WIN_HEIGHT = 600
WIN_H_PADDING = 20

CATEGORIES = [
#        Display name                         ID              Show it? Always False to start              Icon
    {"label": _("Appearance"),            "id": "appear",      "show": False,                       "icon": "cat-appearance.svg"},
    {"label": _("Preferences"),           "id": "prefs",       "show": False,                       "icon": "cat-prefs.svg"},
    {"label": _("Hardware"),              "id": "hardware",    "show": False,                       "icon": "cat-hardware.svg"},
    {"label": _("Security"),              "id": "security",    "show": False,                       "icon": "cat-security.svg"},
]

CONTROL_CENTER_MODULES = [
#         Label                              Module ID                Icon                         Category      Advanced?                      Keywords for filter
    [_("Networking"),                       "network",            "network.svg",                 "hardware",      False,          _("network, wireless, wifi, ethernet, broadband, internet")],
    [_("Display"),                          "display",            "display.svg",                 "hardware",      False,          _("display, screen, monitor, layout, resolution, dual, lcd")],
    [_("Regional Settings"),                "region",             "region.svg",                     "prefs",      False,          _("region, layout, keyboard, language")],
    [_("Bluetooth"),                        "bluetooth",          "bluetooth.svg",               "hardware",      False,          _("bluetooth, dongle, transfer, mobile")],
    [_("Universal Access"),                 "universal-access",   "universal-access.svg",           "prefs",      False,          _("magnifier, talk, access, zoom, keys, contrast")],
#    [_("User Accounts"),                    "user-accounts",      "user-accounts.svg",              "prefs",      True,           _("users, accounts, add, password, picture")],
    [_("Power Management"),                 "power",              "power.svg",                   "hardware",      False,          _("power, suspend, hibernate, laptop, desktop")],
    [_("Sound"),                            "sound",              "sound.svg",                   "hardware",      False,          _("sound, speakers, headphones, test")],
    [_("Color"),                            "color",              "color.svg",                   "hardware",      True,           _("color, profile, display, printer, output")]
]

STANDALONE_MODULES = [
#         Label                          Executable                          Icon                Category        Advanced?               Keywords for filter
    [_("Printers"),                      "system-config-printer",        "printer.svg",         "hardware",       False,          _("printers, laser, inkjet")],
#    [_("Languages"),                     "gnome-language-selector",      "language.svg",        "prefs",          True,          _("language, install, foreign")],
    [_("Languages"),                     "mintlocale",                   "language.svg",        "prefs",            True,               _("language, install, foreign")],
    [_("Login Screen"),                  "gksu /usr/sbin/mdmsetup",      "login.svg",           "prefs",          False,           _("login, mdm, gdm, manager, user, password, startup, switch")],
    [_("Startup Programs"),              "gnome-session-properties",     "startup-programs.svg","prefs",          False,          _("startup, programs, boot, init, session")],
    [_("Device Drivers"),                "mintdrivers",                  "drivers.svg",         "hardware",       False,          _("video, driver, wifi, card, hardware, proprietary, nvidia, radeon, nouveau, fglrx")],
    [_("Software Sources"),              "mintsources",                  "sources.svg",         "prefs",          True,           _("ppa, repository, package, source, download")],
    [_("Device Manager"),                "ydm",                          "device-manager.svg",  "hardware",       False,          _("device, manager")] ,
    [_("Firewall"),                      "gufw",                         "firewall.svg",               "security",       False,          _("firewall, block, filter, programs")],
    [_("Network Traffic Monitor"),       "ntm",                          "network-traffic-monitor.svg","security",       False,          _("network, traffic, monitor")],
    [_("Backup Tool"),                   "checkAuth mintBackup",                   "backuptools.svg",             "security",      False,          _("backup, backuptools, tools")],
    [_("Log Parser Managment Tool"),                   "lpmt",                   "log-parser-managment-tool.svg",             "security",      False,          _("log, parser, managment, tools")],
    [_("Users and Groups"),              "cinnamon-settings-users",      "user-accounts.svg",   "prefs",          True,           _("user, users, account, accounts, group, groups, password")],
    [_("Software Manager"),              "checkPermissions gksu mintinstall",                  "sources.svg",         "prefs",          True,           _("install, remove, software")],


]

#begin---------------------------------------------------------------#
CATEGORIES_NEW = [
	{"label": _("User and Group"), "id": "user_group", "show": True, "icon": "user-accounts.svg", "modules":[]},
        {"label": _("Appearance and Customize"), "id": "appear_custom", "show": True, "icon": "cat-appearance.svg", "modules":[]},
        {"label": _("Hardware and Sound"), "id": "hard_sound", "show": True, "icon": "cat-hardware.svg", "modules":[]},
        {"label": _("Time and Zone"), "id": "time_zone", "show": True, "icon": "clock.svg", "modules":[]},
        {"label": _("System and Security"), "id": "sys_security", "show": True, "icon": "cat-security.svg", "modules":[]},
        {"label": _("Net and Security"), "id": "net_security", "show": True, "icon": "network-traffic-monitor.svg", "modules":[]},
        {"label": _("Program"), "id": "program", "show": True, "icon": "sources.svg", "modules":[]}
]

MODULES_NEW = [
#         Label                                         ModuleID/Exec                   Category
        [_("Network setting"),                          "network",                      "net_security"],
        [_("Firewall Setting"),                         "gufw",                          "net_security"],

        [_("System Infomation"),                        "info",                         "sys_security"],
        [_("Backup System"),                            "checkAuth mintBackup",                   "sys_security"],

        [_("Region Setting"),                           "region",                       "time_zone"],
        [_("Time Setting"),                             "calendar",                     "time_zone"],

        [_("Check Device"),                             "ydm",                          "hard_sound"],
        [_("Printer Setting"),                          "system-config-printer",        "hard_sound"],
        [_("Sound Setting"),                            "sound",                        "hard_sound"],

        [_("Theme Setting"),                            "themes",                       "appear_custom"],
        [_("Desktop Setting"),                          "backgrounds",                  "appear_custom"],
        [_("Font Setting"),                             "fonts",                        "appear_custom"],
        [_("Display Setting"),                          "display",                      "appear_custom"],

        [_("Add or Remove User"),                       "cinnamon-settings-users",      "user_group"],
        [_("Add or Remove Group"),                      "cinnamon-settings-groups",      "user_group"],

        [_("Add and Remove Program"),                   "gksu mintinstall",                  "program"],
]

#end---------------------------------------------------------------#


class MainWindow:

    # Change pages
    def side_view_nav(self, side_view, cat):
        selected_items = side_view.get_selected_items()
        if len(selected_items) > 0:
            self.deselect(cat)
            filtered_path = side_view.get_model().convert_path_to_child_path(selected_items[0])
            if filtered_path is not None:
                self.go_to_sidepage(cat, filtered_path)

    def go_to_sidepage(self, cat, path):        
        iterator = self.store[cat].get_iter(path)
        sidePage = self.store[cat].get_value(iterator,2)
        if not sidePage.is_standalone:
            self.side_view_sw.hide()
            self.search_entry.hide()
#begin---------------------------------------------------------------#
           # self.menu_toggle_button.hide()
            self.mode_combo_box.hide()
#end---------------------------------------------------------------#
    
            self.window.set_title(sidePage.name)
            sidePage.build(self.advanced_mode)
            self.content_box_sw.show()
            self.button_back.show()
            self.current_sidepage = sidePage
            self.maybe_resize(sidePage)
            GObject.idle_add(self.start_fade_in)
        else:
            sidePage.build(self.advanced_mode)
#begin---------------------------------------------------------------#
    def jump_to_sidepage(self, btn, sidePage):
        if not sidePage.is_standalone:
            self.side_view_sw.hide()
            self.search_entry.hide()
            #self.menu_toggle_button.hide()
            self.mode_combo_box.hide()
            self.window.set_title(sidePage.name)
            sidePage.build(self.advanced_mode)
            self.content_box_sw.show()
            self.button_back.show()
            self.current_sidepage = sidePage
            self.maybe_resize(sidePage)
            GObject.idle_add(self.start_fade_in)
        else:
            sidePage.build(self.advanced_mode)

    def on_changed_mode(self, combo):
        tree_iter = combo.get_active_iter()
        if tree_iter != None:
            mod = combo.get_model()
        if mod[tree_iter][1]:#adv
            self.on_advanced_mode()
        else:#nor
            self.on_normal_mode()
#end---------------------------------------------------------------#


    def maybe_resize(self, sidePage):
        if not sidePage.size:
            m, n = self.content_box.get_preferred_size()
            self.window.resize(WIN_WIDTH, n.height + self.bar_heights + WIN_H_PADDING)
        elif sidePage.size > -1:
            self.window.resize(WIN_WIDTH, sidePage.size + self.bar_heights + WIN_H_PADDING)

    def deselect(self, cat):
        for key in self.side_view.keys():
            if key is not cat:
                self.side_view[key].unselect_all()

    ''' Create the UI '''
    def __init__(self):

        self.builder = Gtk.Builder()
        self.builder.add_from_file("/usr/lib/cinnamon-settings/cinnamon-settings.ui")
        self.window = self.builder.get_object("main_window")
        self.top_bar = self.builder.get_object("top_bar")
        self.bottom_bar = self.builder.get_object("bottom_bar")
        self.side_view = {}
        self.side_view_container = self.builder.get_object("category_box")
        self.side_view_sw = self.builder.get_object("side_view_sw")
        self.side_view_sw.show_all()
        self.content_box = self.builder.get_object("content_box")
        self.content_box_sw = self.builder.get_object("content_box_sw")
#        self.button_cancel = self.builder.get_object("button_cancel")
        self.button_back = self.builder.get_object("button_back")
#self.button_back.set_label(_("All Settings"))
        self.button_back.set_label(_("Backward"))
        self.button_back.hide()

        self.search_entry = self.builder.get_object("search_box")
        self.search_entry.connect("changed", self.onSearchTextChanged)
        self.search_entry.connect("icon-press", self.onClearSearchBox)
        self.window.connect("destroy", Gtk.main_quit)

        self.builder.connect_signals(self)
        self.window.set_has_resize_grip(False)
        self.sidePages = []
        self.settings = Gio.Settings.new("org.cinnamon")
        self.advanced_mode = self.settings.get_boolean(ADVANCED_GSETTING)
	print "ADVANCED_GSETTING="+ADVANCED_GSETTING
#        self.mode_button = self.builder.get_object("mode_button")
#        self.mode_button.set_size_request(self.get_mode_size(), -1)
#        if self.advanced_mode:
#            self.mode_button.set_label(NormalMode)
#        else:
#            self.mode_button.set_label(AdvancedMode)

        self.current_sidepage = None
        self.c_manager = capi.CManager()
        self.content_box.c_manager = self.c_manager
        self.bar_heights = 0
        self.opacity = 0

        for i in range(len(modules)):
            try:
                mod = modules[i].Module(self.content_box)
                if self.loadCheck(mod) and self.setParentRefs(mod):
                    self.sidePages.append((mod.sidePage, mod.name, mod.category))
#begin---------------------------------------------------------------#
                    for it in MODULES_NEW:
                        if mod.name == it[1]:
                            it.append(mod.sidePage)
#end---------------------------------------------------------------#
            except:
                print "Failed to load module %s" % modules[i]
                import traceback
                traceback.print_exc()

        for item in CONTROL_CENTER_MODULES:
            ccmodule = SettingsWidgets.CCModule(item[0], item[1], item[2], item[3], item[4], item[5], self.content_box)
            if ccmodule.process(self.c_manager):
                self.sidePages.append((ccmodule.sidePage, ccmodule.name, ccmodule.category))
#begin---------------------------------------------------------------#
                for it in MODULES_NEW:
                    if ccmodule.name == it[1]:
                                it.append(ccmodule.sidePage)
#end---------------------------------------------------------------#


        for item in STANDALONE_MODULES:
            samodule = SettingsWidgets.SAModule(item[0], item[1], item[2], item[3], item[4], item[5], self.content_box)
            if samodule.process():
                self.sidePages.append((samodule.sidePage, samodule.name, samodule.category))
#begin---------------------------------------------------------------#
                for it in MODULES_NEW:
                    if samodule.name == it[1]:
                                it.append(samodule.sidePage)
#end---------------------------------------------------------------#

#begin---------------------------------------------------------------#
        for it in MODULES_NEW:
            #special case: cinnamon-settings-groups
            if it[1] == "cinnamon-settings-groups":
                sa = SettingsWidgets.SAModule(_("Users and Groups"), "cinnamon-settings-groups", "user-accounts.svg", "prefs", True, _("user, users, account, accounts, group, groups, password"), self.content_box)
                if samodule.process():
                    it.append(sa.sidePage)
            if it[1] == "gksu mintinstall":
                sa = SettingsWidgets.SAModule(_("Add and Remove Program"), "checkPermissions gksu mintinstall", "sources.svg", "prefs", True,  _("ppa, repository, package, source, download"), self.content_box)
                
                if samodule.process():
                    it.append(sa.sidePage)
 
            for cat in CATEGORIES_NEW:
                if cat["id"] == it[2] and len(it) >= 4:
                    cat["modules"].append({"label":it[0], "name":it[1], "category":it[2], "sidePage":it[3]})

        #self.menu_toggle_button = self.builder.get_object("menu_toggle_button")
#end---------------------------------------------------------------#
        # create the backing stores for the side nav-view.
        sidePagesIters = {}
        self.store = {}
        self.storeFilter = {}
        for sidepage in self.sidePages:
            sp, sp_id, sp_cat = sidepage
            if not self.store.has_key(sp_cat):  #       Label         Icon          sidePage     Category
                self.store[sidepage[2]] = Gtk.ListStore(str,    GdkPixbuf.Pixbuf,    object,     str)
                for category in CATEGORIES:
                    if category["id"] == sp_cat:
                        category["show"] = True
            iconFile = "/usr/lib/cinnamon-settings/data/icons/%s" % sp.icon
            if os.path.exists(iconFile):
                img = GdkPixbuf.Pixbuf.new_from_file_at_size( iconFile, 48, 48)
            else:
                img = None
            sidePagesIters[sp_id] = self.store[sp_cat].append([sp.name, img, sp, sp_cat])

        for key in self.store.keys():
            self.storeFilter[key] = self.store[key].filter_new()
            self.storeFilter[key].set_visible_func(self.filter_visible_function)


        # set up larger components.
        self.window.set_title(_("System Settings"))
        self.window.connect("destroy", Gtk.main_quit)
#        self.button_cancel.connect("clicked", Gtk.main_quit)
        self.button_back.connect('clicked', self.back_to_icon_view)
        self.window.set_opacity(self.opacity)
        self.window.show()
        self.calculate_bar_heights()

        # Select the first sidePage
        if len(sys.argv) > 1 and sys.argv[1] in sidePagesIters.keys():
            first_page_iter = sidePagesIters[sys.argv[1]]
            self.findPath(first_page_iter)
        else:
            self.search_entry.grab_focus()
            GObject.idle_add(self.start_fade_in)
#begin---------------------------------------------------------------#
        self.policy_bak = None
        self.mode_combo_box = self.builder.get_object("combo_box")
        combo_store = Gtk.ListStore(str, bool)
        combo_store.append([NormalMode, False])
        combo_store.append([AdvancedMode, True])
        mode_combo = Gtk.ComboBox.new_with_model(combo_store)
        rt = Gtk.CellRendererText()
        mode_combo.pack_start(rt, True)
        mode_combo.add_attribute(rt, "text", 0)
        mode_combo.connect("changed", self.on_changed_mode)
        self.mode_combo_box.pack_start(mode_combo, False, False, 1)
        self.mode_combo_box.show_all()
        if not self.advanced_mode:
            self.search_entry.hide()
            mode_combo.set_active(0)####
        else:
            mode_combo.set_active(1) 
#end---------------------------------------------------------------#


#    def get_mode_size(self):
#        self.mode_button.set_label(AdvancedMode)
#        amw, apw = self.mode_button.get_preferred_width()
#        self.mode_button.set_label(NormalMode)
#        nmw, npw = self.mode_button.get_preferred_width()
#        return max(apw, npw)

    def start_fade_in(self):
        if self.opacity < 1.0:
            GObject.timeout_add(10, self.do_fade_in)
        return False

    def do_fade_in(self):
        self.opacity += 0.05
        self.window.set_opacity(self.opacity)
        return self.opacity < 1.0

    def calculate_bar_heights(self):
        h = 0
        m, n = self.top_bar.get_preferred_size()
        h += n.height
        m, n = self.bottom_bar.get_preferred_size()
        h += n.height
        self.bar_heights = h

    def onSearchTextChanged(self, widget):
#begin---------------------------------------------------------------#
        if self.advanced_mode:
#end---------------------------------------------------------------#
            self.displayCategories()

    def onClearSearchBox(self, widget, position, event):
        if position == Gtk.EntryIconPosition.SECONDARY:
            self.search_entry.set_text("")

    def filter_visible_function(self, model, iter, user_data = None):
        sidePage = model.get_value(iter, 2)
        text = self.search_entry.get_text().lower()
        if sidePage.advanced:
            if not self.advanced_mode:
                return False
        if sidePage.name.lower().find(text) > -1 or \
           sidePage.keywords.lower().find(text) > -1:
            return True
        else:
            return False

    def displayCategories(self):
	widgets = self.side_view_container.get_children()
        for widget in widgets:
            widget.destroy()
        self.first_category_done = False # This is just to prevent an extra separator showing up before the first category
        for category in CATEGORIES:
            if category["show"] is True:
                self.prepCategory(category)
        self.side_view_container.show_all()

    def prepCategory(self,category):
	self.storeFilter[category["id"]].refilter()
        if not self.anyVisibleInCategory(category):
            return
        if self.first_category_done:
            widget = Gtk.Separator.new(Gtk.Orientation.HORIZONTAL)
            self.side_view_container.pack_start(widget, False, False, 10)
        box = Gtk.Box.new(Gtk.Orientation.HORIZONTAL, 4)
        iconFile = "/usr/lib/cinnamon-settings/data/icons/%s" % category["icon"]
        if os.path.exists(iconFile):
            img = GdkPixbuf.Pixbuf.new_from_file_at_size( iconFile, 30, 30)
            box.pack_start(Gtk.Image.new_from_pixbuf(img), False, False, 4)
        else:
            img = None

        widget = Gtk.Label()
        widget.set_use_markup(True)
        widget.set_markup('<span size="12000">%s</span>' % category["label"])
        widget.set_alignment(.5, .5)
        box.pack_start(widget, False, False, 1)
        self.side_view_container.pack_start(box, False, False, 0)
        widget = Gtk.IconView.new_with_model(self.storeFilter[category["id"]])
        widget.set_text_column(0)
        widget.set_pixbuf_column(1)
        widget.set_item_width(110)
        widget.set_row_spacing(0)
        widget.set_column_spacing(0)
        widget.set_row_spacing(0)
        widget.set_hexpand(True)
        widget.set_vexpand(False)
        css_provider = Gtk.CssProvider()
        css_provider.load_from_data("GtkIconView {background-color: transparent;}")
        c = widget.get_style_context()
        c.add_provider(css_provider, Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
        self.side_view[category["id"]] = widget
        self.side_view_container.pack_start(self.side_view[category["id"]], False, False, 0)
        self.first_category_done = True
        self.side_view[category["id"]].connect("selection_changed", self.side_view_nav, category["id"])
    def anyVisibleInCategory(self, category):
        id = category["id"]
        iter = self.storeFilter[id].get_iter_first()
        visible = False
        while iter is not None:
            cat = self.storeFilter[id].get_value(iter, 3)
            visible = cat == category["id"]
            iter = self.storeFilter[id].iter_next(iter)
        return visible
#begin---------------------------------------------------------------#
    def displayCategoriesNew(self):
        widgets = self.side_view_container.get_children()
        for widget in widgets:
            widget.destroy()
#        for category in CATEGORIES_NEW:
#            if category["show"] is True:
#                self.prepCategoryNew(category)
        i = 0
        real_CATEGORIES  = [{}]
        
        while i < len(CATEGORIES_NEW):
            if CATEGORIES_NEW[i]["show"] is True and len(CATEGORIES_NEW[i]["modules"])!=0:
                    real_CATEGORIES.append(CATEGORIES_NEW[i])
            i = i+1
        j = 1
        if len(real_CATEGORIES)%2 == 0:
            row = len(real_CATEGORIES)/2+1
            real_CATEGORIES.append('end')
	else:
	    row = len(real_CATEGORIES)/2
        table = Gtk.Table(row-1,2,True)
	table.set_border_width(3)
        self.side_view_container.pack_start(table, False, False, 40)
        while j<len(real_CATEGORIES):
                n = j+1
                row_num = (j-1)/2
                self.prepCategoryNew(row_num,real_CATEGORIES[j],real_CATEGORIES[n],table)
                j = j+2
#	label_test = Gtk.Label()
#	label_test.set_text("sdfgdfgdfg")
#	self.side_view_container.pack_start(label_test, False, False, 0)
        self.side_view_container.show_all()

    def prepCategoryNew(self, row_num,category1,category2,table):
#        if not self.anyVisibleInCategoryNew(category):
#            return
#       {"label": _("x"), "id": "x", "show": True, "icon": "x", "modules":[{label: "x", name: "x", category: "x", sidepage: "x"}]}
	fix1 = Gtk.Fixed()
        vbox1 = Gtk.Box.new(Gtk.Orientation.HORIZONTAL, 0)
        table.attach(fix1,0,1,row_num,row_num+1)
        fix1.put(vbox1,200,0)
        vbox1_left = Gtk.Box.new(Gtk.Orientation.VERTICAL, 0)
        vbox1.pack_start(vbox1_left, False, False, 4)

        iconFile = "/usr/lib/cinnamon-settings/data/icons/%s" % category1["icon"]
        if os.path.exists(iconFile):
            img = GdkPixbuf.Pixbuf.new_from_file_at_size( iconFile, 45, 45)
            vbox1_left.pack_start(Gtk.Image.new_from_pixbuf(img), False, False, 4)
        else:
            img = None
        vbox1_right = Gtk.Box.new(Gtk.Orientation.VERTICAL, 0)
        vbox1.pack_start(vbox1_right, False, False, 4)
	label_fix = Gtk.Fixed()
        widget = Gtk.Label()
        widget.set_use_markup(True)
        widget.set_markup('<span font_desc="12">%s</span>' % category1["label"])
        widget.set_justify(Gtk.Justification.LEFT)
        label_fix.put(widget,0,0)
        vbox1_right.pack_start(label_fix, False, False, 0)
        vbox1_button_box = Gtk.Box.new(Gtk.Orientation.VERTICAL, 0)
        vbox1_right.pack_start(vbox1_button_box, False, False, 0)
        for mod in category1["modules"]:
	        button_label = Gtk.Label()
                label_content = mod["label"]
                button_label.set_use_markup(True)
                button_label.set_text(label_content)
                button_label.set_markup('<span foreground=\"#5F9EA0\" font_desc="8" underline="single"  >%s</span>' % label_content)
                button = Gtk.Button(None,None,True)
                button.add(button_label)
                button.set_alignment(0,0)
                button.set_use_underline(True)
                button.set_relief(Gtk.ReliefStyle.NONE)
		button.connect("clicked", self.jump_to_sidepage, mod["sidePage"])
                vbox1_button_box.pack_start(button, True, False, 0)
	    
        if category2!='end':
            fix2 = Gtk.Fixed()
            vbox2 = Gtk.Box.new(Gtk.Orientation.HORIZONTAL, 0)
            table.attach(fix2,1,2,row_num,row_num+1)
            fix2.put(vbox2,0,0)
            vbox2_left = Gtk.Box.new(Gtk.Orientation.VERTICAL, 0)
            vbox2.pack_start(vbox2_left, False, False, 4)
            iconFile = "/usr/lib/cinnamon-settings/data/icons/%s" % category2["icon"]
            if os.path.exists(iconFile):
                img = GdkPixbuf.Pixbuf.new_from_file_at_size( iconFile, 45, 45)
                vbox2_left.pack_start(Gtk.Image.new_from_pixbuf(img), False, False, 4)
            else:
                img = None
            vbox2_right = Gtk.Box.new(Gtk.Orientation.VERTICAL, 0)
            vbox2.pack_start(vbox2_right, False, False, 0)
	    label_fix = Gtk.Fixed()
            widget = Gtk.Label()
            widget.set_use_markup(True)
            widget.set_markup('<span font_desc="12">%s</span>' % category2["label"])
	    label_fix.put(widget,0,0)
            vbox2_right.pack_start(label_fix, False, False, 0)
            vbox2_button_box =  Gtk.Box.new(Gtk.Orientation.VERTICAL, 0)
            vbox2_right.pack_start(vbox2_button_box, False, False, 0)
	    for mod in category2["modules"]:
                button_label = Gtk.Label()
                label_content = mod["label"]
                button_label.set_use_markup(True)
                button_label.set_text(label_content)
                button_label.set_markup('<span foreground=\"#5F9EA0\" font_desc="8" underline="single"  >%s</span>' % label_content)
                button = Gtk.Button(None,None,True)
                button.add(button_label)
                button.set_alignment(0,0)
                button.set_use_underline(True)
                button.set_relief(Gtk.ReliefStyle.NONE)
                button.connect("clicked", self.jump_to_sidepage, mod["sidePage"])
                vbox2_button_box.pack_start(button, True, True, 0)
	else:
	    button = Gtk.Button(None,None,True)
	    vbox2 = Gtk.Box.new(Gtk.Orientation.HORIZONTAL, 0)
            table.attach(vbox2,1,2,row_num,row_num+1)

    def anyVisibleInCategoryNew(self, category):
        visible = False
        for mod in category["modules"]:
            visible = mod["category"] == category["id"]
        return visible
#end---------------------------------------------------------------#


    def findPath (self, name):
        for key in self.store.keys():
            path = self.store[key].get_path(name)
            if path is not None:
                GObject.idle_add(self.do_side_view, key, path)

    def do_side_view(self, key, path):
        self.go_to_sidepage(key, path)

    def setParentRefs (self, mod):
        try:
            mod._setParentRef(self.window, self.builder)
        except AttributeError:
            pass
        return True

    def loadCheck (self, mod):
        try:
            return mod._loadCheck()
        except:
            return True

    def back_to_icon_view(self, widget):
        self.window.set_title(_("System Settings"))
        self.window.resize(WIN_WIDTH, WIN_HEIGHT)
        self.content_box_sw.hide()
        children = self.content_box.get_children()
        for child in children:
            child.hide()
            if child.get_name() == "c_box":
                c_widgets = child.get_children()
                for c_widget in c_widgets:
                    c_widget.hide()
        self.button_back.hide()
        self.side_view_sw.show()
#begin---------------------------------------------------------------#
        if self.advanced_mode:
            self.search_entry.show()
        #self.menu_toggle_button.show()
        self.mode_combo_box.show()
#end---------------------------------------------------------------#
        self.search_entry.grab_focus()
        self.current_sidepage = None

    def on_menu_button_clicked(self, widget):
#begin---------------------------------------------------------------#
        popup = Gtk.Menu()
        popup.attach_to_widget(widget, None)
        popup_normal_mode = Gtk.CheckMenuItem(NormalMode)
        popup_normal_mode.set_draw_as_radio(True)
        popup_normal_mode.set_active(not self.advanced_mode)
        popup_normal_mode.show()
        popup.append(popup_normal_mode)
        popup_advanced_mode = Gtk.CheckMenuItem(AdvancedMode)
        popup_advanced_mode.set_draw_as_radio(True)
        popup_advanced_mode.set_active(self.advanced_mode)
        popup_advanced_mode.show()
        popup.append(popup_advanced_mode)

        popup_normal_mode.connect('activate', self.on_normal_mode)
        popup_advanced_mode.connect('activate', self.on_advanced_mode)
        popup.popup(None, None, None, None, 0, 0)
#end---------------------------------------------------------------#


    def on_advanced_mode(self):
#begin---------------------------------------------------------------#
	if self.policy_bak:
	    self.side_view_sw.set_policy(self.policy_bak[0],self.policy_bak[1])
        self.advanced_mode = True
	self.search_entry.show()
        self.settings.set_boolean(ADVANCED_GSETTING, True)
        if self.current_sidepage is not None:
            self.current_sidepage.build(self.advanced_mode)
            self.maybe_resize(self.current_sidepage)
        self.displayCategories()

    def on_normal_mode(self):
        self.advanced_mode = False
#begin---------------------------------------------------------------#
	self.policy_bak = self.side_view_sw.get_policy()
	self.side_view_sw.set_policy(Gtk.PolicyType.NEVER,Gtk.PolicyType.NEVER)
        self.search_entry.hide()
#end---------------------------------------------------------------#
        self.settings.set_boolean(ADVANCED_GSETTING, False)
        if self.current_sidepage is not None:
            self.current_sidepage.build(self.advanced_mode)
            self.maybe_resize(self.current_sidepage)
#begin---------------------------------------------------------------#
        self.displayCategoriesNew()
#end---------------------------------------------------------------#


if __name__ == "__main__":
    GObject.threads_init()
    MainWindow()
    Gtk.main()
