#!/usr/bin/env python
# -*- coding: utf-8 -*-
from SettingsWidgets import *

class Module:
    def __init__(self, content_box):
        keywords = _("effects, fancy, window")
        advanced = True
        sidePage = SidePage(_("Effects"), "desktop-effects.svg", keywords, advanced, content_box)
        self.sidePage = sidePage
        self.name = "effects"
        self.category = "appear"
        sidePage.add_widget(GSettingsCheckButton(_("Enable desktop effects"), "org.cinnamon", "desktop-effects", None))

        box = IndentedHBox()
        box.add(GSettingsCheckButton(_("Enable desktop effects on dialog boxes"), "org.cinnamon", "desktop-effects-on-dialogs", "org.cinnamon/desktop-effects"))
        sidePage.add_widget(box)

        # Destroy window effects
        transition_effects = []
        transition_effects.append(["easeInQuad", "二次方加速"])
        transition_effects.append(["easeOutQuad", "二次方减速"])
        transition_effects.append(["easeInOutQuad", "二次方加速然后减速"])        
        transition_effects.append(["easeInCubic", "三次方加速"])
        transition_effects.append(["easeOutCubic", "三次方减速"])
        transition_effects.append(["easeInOutCubic", "三次方加速然后减速"])        
        transition_effects.append(["easeInQuart", "四次方加速"])
        transition_effects.append(["easeOutQuart", "四次方减速"])
        transition_effects.append(["easeInOutQuart", "四次方加速然后减速"])        
        transition_effects.append(["easeInQuint", "五次方加速"])
        transition_effects.append(["easeOutQuint", "五次方减速"])
        transition_effects.append(["easeInOutQuint", "五次方加速然后减速"])        
        transition_effects.append(["easeInSine", "正弦加速"])
        transition_effects.append(["easeOutSine", "正弦减速"])
        transition_effects.append(["easeInOutSine", "正弦加速然后减速"])        
        transition_effects.append(["easeInExpo", "幂次方加速"])
        transition_effects.append(["easeOutEXpo", "幂次方减速"])
        transition_effects.append(["easeInOutExpo", "幂次方加速然后减速"])        
        transition_effects.append(["easeInCirc", "圆加速"])
        transition_effects.append(["easeOutCirc", "圆减速"])
        transition_effects.append(["easeInOutCirc", "圆加速然后减速"])        
        transition_effects.append(["easeInElastic", "弹性加速"])
        transition_effects.append(["easeOutElastic", "弹性减速"])
        transition_effects.append(["easeInOutElastic", "弹性加速然后减速"])        
        transition_effects.append(["easeInBack", "反退加速"])
        transition_effects.append(["easeOutBack", "反退减速"])
        transition_effects.append(["easeInOutBack", "反退加速然后减速"])        
        transition_effects.append(["easeInBounce", "反弹加速"])
        transition_effects.append(["easeOutBounce", "反弹减速"])
        transition_effects.append(["easeInOutBounce", "反弹加速然后减速"])
        
        #CLOSING WINDOWS
        box = IndentedHBox()
        label = Gtk.Label()
        label.set_markup("%s" % _("Closing windows:"))
        box.add(label)
        effects = [["none", _("None")], ["scale", _("Scale")], ["fade", _("Fade")]]        
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-close-effect", "org.cinnamon/desktop-effects", effects))
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-close-transition", "org.cinnamon/desktop-effects", transition_effects))
        box.add(GSettingsSpinButton("", "org.cinnamon", "desktop-effects-close-time", "org.cinnamon/desktop-effects", 0, 2000, 50, 200, _("milliseconds")))
        sidePage.add_widget(box) 
        
        #MAPPING WINDOWS
        box = IndentedHBox()
        label = Gtk.Label()
        label.set_markup("%s" % _("Mapping windows:"))
        box.add(label)
        effects = [["none", _("None")], ["scale", _("Scale")], ["fade", _("Fade")]]        
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-map-effect", "org.cinnamon/desktop-effects", effects))
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-map-transition", "org.cinnamon/desktop-effects", transition_effects))
        box.add(GSettingsSpinButton("", "org.cinnamon", "desktop-effects-map-time", "org.cinnamon/desktop-effects", 0, 2000, 50, 200, _("milliseconds")))
        sidePage.add_widget(box)
        
        #MINIMIZING WINDOWS
        box = IndentedHBox()
        label = Gtk.Label()
        label.set_markup("%s" % _("Minimizing windows:"))
        box.add(label)
        effects = [["none", _("None")], ["traditional", _("Traditional")], ["scale", _("Scale")]]
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-minimize-effect", "org.cinnamon/desktop-effects", effects))
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-minimize-transition", "org.cinnamon/desktop-effects", transition_effects))
        box.add(GSettingsSpinButton("", "org.cinnamon", "desktop-effects-minimize-time", "org.cinnamon/desktop-effects", 0, 2000, 50, 200, _("milliseconds")))
        sidePage.add_widget(box)
        
        #MAXIMIZING WINDOWS
        box = IndentedHBox()
        label = Gtk.Label()
        label.set_markup("%s" % _("Maximizing windows:"))
        box.add(label)
        effects = [["none", _("None")], ["scale", _("Scale")]]        
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-maximize-effect", "org.cinnamon/desktop-effects", effects))
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-maximize-transition", "org.cinnamon/desktop-effects", transition_effects))
        box.add(GSettingsSpinButton("", "org.cinnamon", "desktop-effects-maximize-time", "org.cinnamon/desktop-effects", 0, 2000, 50, 200, _("milliseconds")))
        sidePage.add_widget(box)
        
        #UNMAXIMIZING WINDOWS
        box = IndentedHBox()
        label = Gtk.Label()
        label.set_markup("%s" % _("Unmaximizing windows:"))
        box.add(label)
        effects = [["none", _("None")], ["scale", _("Scale")]]
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-unmaximize-effect", "org.cinnamon/desktop-effects", effects))
        box.add(GSettingsComboBox("", "org.cinnamon", "desktop-effects-unmaximize-transition", "org.cinnamon/desktop-effects", transition_effects))
        box.add(GSettingsSpinButton("", "org.cinnamon", "desktop-effects-unmaximize-time", "org.cinnamon/desktop-effects", 0, 2000, 50, 200, _("milliseconds")))
        sidePage.add_widget(box)

        (status, output)=commands.getstatusoutput('lspci | grep VGA | wc -l')
        (status1, output1)=commands.getstatusoutput('lspci | grep VGA | grep -i NVIDIA | wc -l')
        if output == "1" and output1 == "1":
                pass
        else:
                sidePage.add_widget(GSettingsCheckButton(_("Enable fade effect on Cinnamon scrollboxes (like the Menu application list)"), "org.cinnamon", "enable-vfade", None))
