#!/usr/bin/env python

from SettingsWidgets import *

class Module:
    def __init__(self, content_box):
        keywords = _("menu, start, bookmarks, places, recent")
        advanced = False
        sidePage = SidePage(_("Menu And Panel"), "menu.svg", keywords, advanced, content_box)
        self.sidePage = sidePage
        self.name = "menu"
        self.category = "prefs"
        
	vbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
	self.sidePage.add_widget(vbox)
	
	section = Section(_("Menu Setup"))
#section.add(GSettingsCheckButton(_("Show week numbers in calendar"), "org.cinnamon.calendar", "show-weekdate", None))
        section.add(GSettingsFileChooser(_("Icon"), "org.cinnamon", "menu-icon", None, True))
	#wangyu edit here
        self.menuText = GSettingsEntry(_("Text"), "org.cinnamon", "menu-text", None)
	self.menuText.content_widget.set_max_length(20)
	section.add_expand(self.menuText)
	section.add_expand(Gtk.Label(_("(20 characters at most.)")))
        #wangyu end edit        
        section.add(GSettingsCheckButton(_("Show bookmarks and places"), "org.cinnamon", "menu-show-places", None))
        section.add(GSettingsCheckButton(_("Show recent files"), "org.cinnamon", "menu-show-recent", None))
        section.add(GSettingsCheckButton(_("Enable auto-scrolling in application list"), "org.cinnamon", "menu-enable-autoscroll", None))
                
        section.add(GSettingsCheckButton(_("Open menu when I move my mouse over it"), "org.cinnamon", "activate-menu-applet-on-hover", None))
        section.add(GSettingsCheckButton(_("Enable filesystem path entry in search box"), "org.cinnamon", "menu-search-filesystem", None))
        section.add(GSettingsSpinButton(_("Menu hover delay"), "org.cinnamon", "menu-hover-delay", None, 0, 2000, 50, 200, _("milliseconds")))
	vbox.add(section)
        
        #########SetupPanel######### 
	section = Section(_("Panel Setup"))
        desktop_layouts = [["traditional", _("Traditional (panel at the bottom)")], ["flipped", _("Flipped (panel at the top)")]]        
        desktop_layouts_combo = GSettingsComboBox(_("Panel layout"), "org.cinnamon", "desktop-layout", None, desktop_layouts)
        section.add_expand(desktop_layouts_combo) 
#        label = Gtk.Label()
#        label.set_markup("<i><small>%s</small></i>" % _("Note: If you change the layout you will need to restart Cinnamon and Cinnamon Settings."))
#        sidePage.add_widget(label)

        settings = Gio.Settings.new("org.cinnamon")
        layout_type = settings.get_string("desktop-layout")
        if layout_type != "classic":
            section.add(GSettingsCheckButton(_("Auto-hide panel"), "org.cinnamon", "panel-autohide", None))
            box = IndentedHBox()
            box.add(GSettingsSpinButton(_("Show delay"), "org.cinnamon", "panel-show-delay", "org.cinnamon/panel-autohide", 0, 2000, 50, 200, _("milliseconds")))
            section.add_expand(box)
            box = IndentedHBox()
            box.add(GSettingsSpinButton(_("Hide delay"), "org.cinnamon", "panel-hide-delay", "org.cinnamon/panel-autohide", 0, 2000, 50, 200, _("milliseconds")))
            section.add_expand(box)
        else:
            section.add(GSettingsCheckButton(_("Auto-hide top panel"), "org.cinnamon", "panel-autohide", None))
            box = IndentedHBox()
            box.add(GSettingsSpinButton(_("Show delay"), "org.cinnamon", "panel-show-delay", "org.cinnamon/panel-autohide", 0, 2000, 50, 200, _("milliseconds")))
            section.add_expand(box)
            box = IndentedHBox()
            box.add(GSettingsSpinButton(_("Hide delay"), "org.cinnamon", "panel-hide-delay", "org.cinnamon/panel-autohide", 0, 2000, 50, 200, _("milliseconds")))
            section.add_expand(box)
            section.add(GSettingsCheckButton(_("Auto-hide bottom panel"), "org.cinnamon", "panel2-autohide", None))
            box = IndentedHBox()
            box.add(GSettingsSpinButton(_("Show delay"), "org.cinnamon", "panel2-show-delay", "org.cinnamon/panel2-autohide", 0, 2000, 50, 200, _("milliseconds")))
            section.add_expand(box)
            box = IndentedHBox()
            box.add(GSettingsSpinButton(_("Hide delay"), "org.cinnamon", "panel2-hide-delay", "org.cinnamon/panel2-autohide", 0, 2000, 50, 200, _("milliseconds")))
            section.add_expand(box)

        section.add(GSettingsCheckButton(_("Use customized panel size (otherwise it's defined by the theme)"), "org.cinnamon", "panel-resizable", None))

        box = IndentedHBox()
        box.add(GSettingsCheckButton(_("Allow Cinnamon to scale panel text and icons according to the panel heights"), "org.cinnamon", "panel-scale-text-icons", "org.cinnamon/panel-resizable"))
        section.add_expand(box)

        box = IndentedHBox()
        box.add(GSettingsSpinButton(_("Top panel height"), "org.cinnamon", "panel-top-height", "org.cinnamon/panel-resizable", 0, 200, 1, 5, _("Pixels")))
        section.add_expand(box)

        box = IndentedHBox()
        box.add(GSettingsSpinButton(_("Bottom panel height"), "org.cinnamon", "panel-bottom-height", "org.cinnamon/panel-resizable",  0, 200, 1, 5, _("Pixels")))
        section.add_expand(box)

        section.add(GSettingsCheckButton(_("Panel edit mode"), "org.cinnamon", "panel-edit-mode", None))
	vbox.add(section)
