#!/usr/bin/env python

import os
from SettingsWidgets import *

class Module:
    def __init__(self, content_box):
        max_away_message_length = 20
        keywords = _("screensaver, brightness, lock, password, away, message")
        advanced = False
        sidePage = ScreenSidePage(_("Screensaver & Lock Settings"), "screensaver.svg", keywords, advanced, content_box)
        self.sidePage = sidePage
        self.name = "screensaver"
        self.category = "prefs"

class ScreenSidePage (SidePage):
    def __init__(self, name, icon, keywords, advanced, content_box):
        SidePage.__init__(self, name, icon, keywords, advanced, content_box)
        self.max_away_message_length = 20

    def build(self, advanced):
	widgets = self.content_box.get_children()
	for widget in widgets:
	    self.content_box.remove(widget)

        if os.path.exists("/usr/bin/cinnamon-screensaver-command"):
	    self.content_box.pack_start(GSettingsCheckButton(_("Ask for an away message when locking the screen from the menu"), "org.cinnamon.screensaver", "ask-for-away-message", None), True, True, 2)
	    
            gSettingsEntry = GSettingsEntry(_("Default away message"), "org.cinnamon.screensaver", "default-message", None)
            gSettingsEntry.set_max_away_message_length(self.max_away_message_length)
	    self.content_box.pack_start(gSettingsEntry, True, True, 2)

        widget = self.content_box.c_manager.get_c_widget("screen")
        if widget is not None:
            cheat_box = Gtk.Box.new(Gtk.Orientation.VERTICAL, 2)
            cheat_box.pack_start(widget, False, False, 2)
            cheat_box.set_vexpand(False)
            widget.show()
	    self.content_box.pack_start(cheat_box, True, True, 2)

	self.content_box.show_all()
